#ifndef XINEMA_H_
#define XINEMA_H_

#include <msp/core/application.h>
#include <msp/fs/path.h>
#include <msp/graphics/display.h>
#include <msp/graphics/window.h>
#include "networkinterface.h"

class XineEngine;
class XineStream;

class Xinema: public Msp::RegisteredApplication<Xinema>
{
private:
	struct EarlyInit
	{
		EarlyInit();
	};

public:
	sigc::signal<void, XineStream &> signal_stream_created;

private:
	EarlyInit early_init;
	Msp::Graphics::Display display;
	Msp::Graphics::Window window;
	NetworkInterface network;
	XineEngine *engine;
	XineStream *stream;

	Msp::Mutex command_mutex;
	std::string pending_mrl;

public:
	Xinema(int, char **);

	virtual int main();
private:
	virtual void tick();

public:
	void play_file(const Msp::FS::Path &);
	XineStream *get_stream() const { return stream; }
};

#endif
